---
title: Node.removeChild()
slug: Web/API/Node/removeChild
tags:
  - API
  - DOM
  - Method
  - NeedsSpecTable
  - Node
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>Node.removeChild()</strong></code> method removes a child node from the DOM and returns the removed node.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>oldChild</em> = <em>node</em>.removeChild(<em>child</em>);
</pre>

<p>Or just:</p>

<pre class="syntaxbox notranslate"><em>node</em>.removeChild(<em>child</em>);
</pre>

<ul>
 <li><code>child</code> is the child node to be removed from the DOM.</li>
 <li><code>node</code> is the parent node of <code>child</code>.</li>
 <li><code>oldChild</code> holds a reference to the removed child node, i.e., <code>oldChild === child</code>.</li>
</ul>

<p>The removed child node still exists in memory, but is no longer part of the DOM. With the first syntax form shown, you may reuse the removed node later in your code, via the <code>oldChild</code> object reference.</p>

<p>In the second syntax form, however, there is no <code>oldChild</code> reference kept, so assuming your code has not kept any other reference to the node elsewhere, it will immediately become unusable and irretrievable, and will usually be <a href="/en-US/docs/Web/JavaScript/Memory_Management">automatically deleted</a> from memory after a short time.</p>

<p>If <code>child</code> is actually not a child of the <code>element</code> node, the method throws an exception. This will also happen if <code>child</code> was in fact a child of <code>element</code> at the time of the call, but was removed by an event handler invoked in the course of trying to remove the element (e.g., {{Event("blur")}}.)</p>

<h3 id="Errors_thrown">Errors thrown</h3>

<p>The method throws an exception in 2 different ways:</p>

<ol>
 <li>
  <p>If the <code>child</code> was in fact a child of <code>element</code> and so existing on the DOM, but was removed the method throws the following exception:</p>

  <p><code>Uncaught NotFoundError: Failed to execute 'removeChild' on 'Node': The node to be removed is not a child of this node</code>.</p>
 </li>
 <li>
  <p>If the <code>child</code> doesn't exist on the DOM of the page, the method throws the following exception:<br>
   <br>
   <code>Uncaught TypeError: Failed to execute 'removeChild' on 'Node': parameter 1 is not of type 'Node'.</code></p>
 </li>
</ol>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_examples">Simple examples</h3>

<p>Given this HTML:</p>

<pre class="brush: html notranslate">&lt;div id="top"&gt;
  &lt;div id="nested"&gt;&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>To remove a specified element when knowing its parent node:</p>

<pre class="brush:js notranslate">let d = document.getElementById("top");
let d_nested = document.getElementById("nested");
let throwawayNode = d.removeChild(d_nested);
</pre>

<p>To remove a specified element without having to specify its parent node:</p>

<pre class="brush:js notranslate">let node = document.getElementById("nested");
if (node.parentNode) {
  node.parentNode.removeChild(node);
}
</pre>

<p>To remove all children from an element:</p>

<pre class="brush:js notranslate">let element = document.getElementById("top");
while (element.firstChild) {
  element.removeChild(element.firstChild);
}
</pre>

<h3 id="Causing_a_TypeError">Causing a TypeError</h3>

<pre class="brush: html notranslate">&lt;!--Sample HTML code--&gt;
&lt;div id="top"&gt; &lt;/div&gt;

&lt;script type="text/javascript"&gt;
  let top = document.getElementById("top");
  let nested = document.getElementById("nested");

  // Throws Uncaught TypeError
  let garbage = top.removeChild(nested);
&lt;/script&gt;
</pre>

<h3 id="Causing_a_NotFoundError">Causing a NotFoundError</h3>

<pre class="brush: html notranslate">&lt;!--Sample HTML code--&gt;
&lt;div id="top"&gt;
  &lt;div id="nested"&gt;&lt;/div&gt;
&lt;/div&gt;

&lt;script type="text/javascript"&gt;
  let top = document.getElementById("top");
  let nested = document.getElementById("nested");

  // This first call correctly removes the node
  let garbage = top.removeChild(nested);

  // Throws Uncaught NotFoundError
  garbage = top.removeChild(nested);
&lt;/script&gt;
</pre>

<h2 id="Notes">Notes</h2>

<p>Unlike {{domxref ("Node.cloneNode()")}} the return value preserves the {{domxref ("EventListener")}}s.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-node-removechild", "Node: removeChild")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Node.removeChild")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Node.replaceChild()")}}</li>
 <li>{{domxref("Node.parentNode")}}</li>
 <li>{{domxref("ChildNode.remove()")}}</li>
 <li>{{domxref("Node.cloneNode()")}}</li>
</ul>
